## RANDOM
## This file sources the implementation of the abstract domains and
## provides some functions which are commonly used.

## Copyright 2008-2012 Gianluca Amato, Francesca Scozzari

## This file is part of RANDOM: R-based Analyzer for Numerical DOMains
##
## RANDOM is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## RANDOM is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty ofa
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with RANDOM.  If not, see <http://www.gnu.org/licenses/>.

## Dot product with the additional property that 0 * +-Inf is considered
## equal to 0

dot.product <- function (v1,v2) {
	zero.indexes <- which(v1!=0)
	sum(v1[zero.indexes]*v2[zero.indexes])
}

dot.product.gmp <- function (v1,v2) {
	nozero.indexes <- which(v1!=0)
	if (any(is.na(v2[nozero.indexes])))
		as.integer(NA)
	else     
		sum(v1[nozero.indexes]*v2[nozero.indexes])
}

# An ifelse function specialized for sign

ifsign <- function(x,b,c) {
	ifelse(x==0, 0, ifelse(x>0, b, c))
}

ifsign.gmp <- function(x,b,c) {
	ifelse.bigqi(x==0, 0, ifelse.bigqi(x>0, b, c))
}

source("box.R")
source("template.ptopes.R")
source("combined.R")
source("box.gmp.R")
source("template.ptopes.gmp.R")
source("combined.gmp.R")
source("ptopes.R")
source("ptopes.gmp.R")

