## S3 method for the GCD: greatest common divisor

## Copyright 2008-2012 Gianluca Amato, Francesca Scozzari

## This file is part of RANDOM: R-based Analyzer for Numerical DOMains
##
## RANDOM is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## RANDOM is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with RANDOM.  If not, see <http://www.gnu.org/licenses/>.

gcd <- function(v,...) { 
	gcd.positive <- function(v, ...) {
		if (length(v)==1)
			v[1]
		else
			gcd.pair(v[1], gcd.positive(v[-1], ...), ...)
	}
	gcd.positive(abs(v),...)
}

gcd.pair <- function (a,b, ...) UseMethod("gcd.pair")

gcd.pair.default = function(a,b, zero.threshold = 1e-5) {	
	if (b < zero.threshold) a
	else gcd.pair(b, a-b*(a%/%b), zero.threshold)	
}

gcd.pair.bigq <- function(a, b, zero.threshold = as.bigq(1,10000)) {			
	if (b < zero.threshold) a 
	else gcd.pair(b, a-b*as.bigq(as.bigz(a/b)), zero.threshold)
}

gcd.pair.bigz <- function(a, b) gcd.bigz(a,b)

