## Copyright 2008-2012 Gianluca Amato, Francesca Scozzari

## This file is part of RANDOM: R-based Analyzer for Numerical DOMains
##
## RANDOM is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## RANDOM is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with RANDOM.  If not, see <http://www.gnu.org/licenses/>.

# The solve function on bigq does not work well.. there are matrix that it
# says are not invertible, although they are. This is a trick which works for
# integer matrix.

solve.trick <- function (m) {	
	if (all(as.bigq(as.bigz(m))==m)) {		
		m <- matrix(as.numeric(m), ncol=ncol(m)) 
		d <- round(det(m))
		adj <- round(solve(m) * det(m))
		inverse <- matrix(as.bigq(adj)/d, nrow=nrow(m))
		return(inverse)
	} else 
		tryCatch (
				solve(m),
				silent = TRUE,
				error = function(e) {
					m.double <- matrix(as.numeric(m), ncol=ncol(m), nrow=nrow(m))
					if (abs(det(m.double)) > 1e-5) 
						signalCondition(simpleCondition("You hit an error in the gmp bindings for R: there are non-singular matrices which cannot be inverted correctly."))
					else
						stop(e)
				}
		)		
}
