## RANDOM
## This is the dialog box for selecting variables

## Copyright 2010 Gianluca Amato, Francesca Scozzari

## This file is part of RANDOM: R-based Analyzer for Numerical DOMains
##
## RANDOM is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
##
## RANDOM is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with RANDOM.  If not, see <http://www.gnu.org/licenses/>.

varsdialog.new <- function(state,builder) {
	dialog <- builder$getObject("varsdialog")	
	treeview <- builder$getObject("treeview_vars")
	liststore <- treeview$getModel()
	
	init <- function()
	{
		treeview$getSelection()$setMode("multiple")	
	}	
	
	setVariables <- function(variables)
	{
		liststore$clear()
		for (v in variables) {
			iter <- liststore$append()$iter
			liststore$set(iter,0,v)
		}				
	}
	
	getVariables <- function()
	{
		selection <- treeview$getSelection()$getSelectedRows()$retval		
		sapply(selection, function(path) {
					iter <- liststore$getIter(path)$iter
					liststore$getValue(iter,0)$value
				})
	}
	
	run <- function () {
		if (!script.parse()) return(FALSE)
		result <- dialog$run()
		dialog$hide()
		result
	}
	
	init()
	list(run = run, setVariables=setVariables, getVariables=getVariables)	
}
